
class Count3s {

  final static int t = 2;
  static int[] array;
  final static int length = 100000;
  static int count;
  static Object lock;

  static class Count3sProc implements PoPPThread.Proc {
    int id;

    Count3sProc(int id) { 
      this.id = id; 
    }

    public void run() {
      int lengthPerThread = length / t;
      int start = id * lengthPerThread;
      int localCount = 0;
      
      for (int j = 0; j < 10000; j++) {
        for (int i = start; i < start + lengthPerThread; i++) {
          if (array[i] == 3) {
            localCount++;
          }
        }
      }

      synchronized(lock) {
        count += localCount;
      }
    }
  }

  static int count3s()
    throws InterruptedException {

    count = 0;
    lock = new Object();
    
    for (int i = 0; i < t; i++)
      new PoPPThread(new Count3sProc(i));

    PoPPThread.joinThreads();
    
    return count;
  }

  static void makeArray()  {
    array = new int[length];
    for (int i = 0; i < length; i++)
      array[i] = i % 10;
  }

  public static void main(String[] argv) {
    makeArray();

    try {
      System.out.println(count3s());
    } catch (InterruptedException e) {
    }
  }
}
